An Introduction to NetWeaver SAPSetup – SAP’s Front-End Software Deployment Tool

NetWeaver SAPSetup – SAP’s Front-End Software Deployment Tool

NetWeaver SAPSetup is SAP’s Windows Front-End Software Deployment Tool.

This powerful multi-product installer allows the administrator to collect many SAP front-end components (or front-end products) on an Installation Server, and then perform installations, updates or un-installations on workstations via a network.

The purpose of this document is in making you familiar with creating, administering, and using an Installation Server.

For help with installing software on workstations, read Workstation Installation Help.chm in the SETUP directory of the CD / Installation Server.

Also read: Latest News on SAP Front-End Installer | General Tools and Features Overview | Setting up an Installation Server


What’s New in NetWeaver SAPSetup

Latest News on SAP Front-End Installer

This section describes what is new:

● SAP Automatic Workstation Update Service

Whenever the installation server is patched, or the packages installed are updated, this service will update the workstation(s) and reboot them if necessary. The workstation updater works in two modes - one in the presence of a logged-on user and another in his or her absence:

○ When a user is logged on, the user is informed of update availability and the update happens on the user's assent. The user is also informed if a reboot is necessary and the reboot is also only executed on the user's assent.

○ If no user is logged on, the update is done automatically and the reboot (if necessary) is done automatically, too.

This service updates itself, when a patch of automatic workstation update is available.

● New automatic folder configuration for NWCreateInstServer.exe

With NWCreateInstServer.exe, the administrator creates the installation server before using it as a distribution point. During server creation, the administrator can mention the installation server path where he or she wants the installation server to be. With the new configuration feature, the folder is automatically shared and configured. The folder which is created will be made NULL-session accessible by default. Thus, it will be automatically shared on the network for everyone to read. If you do not want automatic configuration, you should use the command line parameter DontConfigureServerPath.

See also General Tools and Features Overview.


What’s New in NetWeaver SAPSetup

General Tools and Features Overview

In this section you find a general overview of the NetWeaver SAPSetup Tools/Utilities and Features.

Tools and Utilities

For the Installation Server

  • Installation Server Creation Tool (NWCreateInstServer.exe): Helps in creating a basic Installation Server and configures.NET Security to administer it over a network path.
  • Installation Server Update Tool (NWUpdateInstServer.exe): Used to update an Installation Server with SAP Front-End Components. This utility will also automatically update older versions existing on an Installation Server by newer ones.
  • Installation Server Administration Tool (NWSAPSetupAdmin.exe): Helps in maintaining and configuring an Installation Server, creating packages, importing products, etc.

For the Workstation:

  • Front-End Installation Tool (NWSAPSetup.exe): Used to install SAP Front-End Components available on a distribution media / CD / Installation Server on a Workstation, to update an installation or to perform un-installations.

Features

On the Installation Server:

SAP’s Front-End Software Deployment Tool – NetWeaver SAPSetup not only allows direct installations from distribution media, but also an Installation Server based deployment mechanism that helps distribute SAP Front-End Software to workstations over a network. The Installation Server provides the following features:

  • The Installation Server can be configured to manage and hold many SAP Front-End Components:

○ The "Import Product" feature allows the administrator to bring new SAP Front-End Components into an existing Installation Server for distribution over the network.

○ The "Export Product" feature allows the export of an SAP Front-End Component from one Installation Server to another.

○ The "Delete Product" feature allows the deletion of an SAP Front-End Component from an Installation Server.

  • The folder for installation server creation is automatically configured. By default, it is made NULL-session accessible. Thus, it will be automatically shared on the network for everyone to read. This feature can also be switched off.
  • Packages can be created and configured to contain and deploy multiple SAP Front-End Components. You can create packages to regulate installation parameters (for example: installation paths). The installation for these packages can be customized using VB script.
  • You can create a package definition file (PDF) for an installation server package. PDF is a package description format that simplifies the interoperability and information exchange between the SAP Installer and system management products like the System Management Server from Microsoft.
  • Local Security Handling (LSH) allows users on the network with non-administrative privileges on their workstations to install SAP Front-End Software.
  • Patching of SAP components on the Installation Server allows for unattended automatic distribution of the patch to the workstations on the network using a command-line.

· Alternatively, the configuration of the SAPSetup Automatic Workstation Update Service will update the workstations and reboot them if necessary, whenever the installation server is patched, or the packages installed are updated. The workstation updater works in two modes - one in the presence of a logged-on user and another in his or her absence:

○ When a user is logged on, the user is informed of update availability and the update happens on the user's assent. The user is also informed if a reboot is necessary and the reboot is also only executed on the user's assent.

○ If no user is logged on, the update is done automatically and the reboot (if necessary) is done automatically, too.

  • For the update of SAP GUI, you could alternatively also use the SAP Logon-enabled update feature. In contrast to the SAP Automatic Workstation Update described above, this method is dependent on user actions. After a certain number of double-clicks on the SAP Logon icon on the desktop, a check for updates is executed.
  • With the Replicate feature you can create copies of the Installation Server on the Network to reduce load.

Most of these features can be accessed using NWSAPSetupAdmin.exe that is available on the SETUP directory of an Installation Server.

On the Workstation:

  • This one installer is capable of managing multiple SAP Front-End Components deployed on the Workstations.
  • With the installer, it is possible to install new components, uninstall existing ones and update the rest in one cycle.
  • It features the installation and maintenance of multiple SAP Front-End Components on the Workstation using a single command-line.

· An Automatic Workstation Update Service will update the workstations and reboot them if necessary, whenever the installation server is patched, or the packages installed are updated.

Error Management and Logging

  • The tools mentioned above record errors in specific in an XML file that can be found inside %ProgramFiles%\Sap\SAPSetup\Errors. This file can be viewed in any browser as a web-page.
  • Log files are maintained under %ProgramFiles%\Sap\SAPSetup\Logs.

If you face problems in using the new installation tool, remember to visit the Troubleshooting and FAQs pages.

Also read: Setting Up an Installation Server


Setting Up an Installation Server

Use

Setting up an Installation Server helps distribute SAP Front-End Software on multiple workstations on the Network.

Prerequisites

You need local administrator rights under Windows 2000, Windows XP or Windows Vista.

Procedure

NWCreateInstServer is a wizard driven tool that helps the administrator create a new Installation Server. On server creation, another utility called NWUpdateInstServer is started to get SAP Products from the source into the newly created server.

Step 1: Starting the Tool - NWCreateInstServer

  1. Start NWCreateInstServer.exe from the SETUP folder of the CD / SAP Product Media.
  2. Click Next to continue.

Clicking the Cancel button at any stage will abort the process.

Step 2: Supplying a path for the Installation Server

You will now be prompted to supply a path where you would wish to create an Installation Server.

  1. Using the Browse button, navigate to a folder where you would like to store the Installation Server Files.

The folder is automatically shared and configured. The folder which is created will be made NULL-session accessible by default. Thus, it will be automatically shared on the network for everyone to read. If you do not want automatic configuration, you should use the command line parameter DontConfigureServerPath.

  2. Click Verify. On successful verification, you should see a Next button.

The verification process checks against the following requirements:

· The folder should exist.

· The Administrator should have full-access on it.

  3. Click Next to continue with Installation Server creation.

Step 3: The actual Server Creation process

You should now see a page that indicates the progress in Installation Server creation. This will take a short while. Please wait for this process to complete.

Step 4: Checking on Installation Server creation success

You now have a valid SAPSetup Installation Server. Note that this is an “empty” Installation Server (i.e. one without any SAP Components available for distribution).

Click Next to start NWUpdateInstServer.

Diagnosing errors

In event of errors, SAPSetup will provide you with a link titled Error Report. Clicking on it will display errors maintained in NwCreateInstServerErrors_CurrentDateTime.xml using your default web-browser.

This xml file is saved in the folder: %ProgramFiles%\Sap\SAPSetup\Errors

A record of Installation Server creation process activity is logged in NWCreateInstServer.log.

This log file is saved in the folder: %ProgramFiles%\Sap\SAPSetup\Logs

Supplying these two files to SAP Support will help in resolving problems quickly – should you face any.

Step 5: Getting (new) SAP Components to the Installation Server

NWUpdateInstServer.exe is started automatically at the end of Installation Server creation by NWCreateInstServer. This tool will update the newly created Installation Server with SAP Components / Product(s) available on the source.

Click Next to continue.

Step 6: Verification of Server Path

In this case, C:\MyNewInstServer is the path where NWCreateInstServer.exe initially created a new Installation Server as seen in Step 2.

(If you wish to update a server different from this one, please use the Browse button to modify that path.)

Click Next to initiate the Server Update process.

Step 7: The server update in action

NWUpdateInstServer is now bringing all SAP Products available on the CD / Source to the Installation Server. This will take a while. Please wait for this process to complete.

Step 8: Checking on success

The Installation Server is now ready to use for SAP Front-End Installation on end-user Workstations. You can either install these components directly, or create packages that contain them on the installation server for deployment.

Note: If you have .NET Framework version 2.0 installed, clicking “Finish” will automatically start NWSAPSetupAdmin.exe from the recently updated Installation Server.

The new NetWeaver SAPAdmin is a multi-product server administration tool. It is discussed in greater detail in the next section.

Diagnosing errors

In event of errors, SAPSetup will provide you with a link titled Error Report. Clicking on it will display Errors maintained in NwUpdateInstServerErrors_CurrentDateTime.xml using your default web-browser.

This xml file is saved in the folder: %ProgramFiles%\Sap\SAPSetup\Errors

A record of process activity is logged in NWUpdateInstServer.log.

This log file is saved in the folder: %ProgramFiles%\Sap\SAPSetup\Logs.

Supplying these two files to SAP Support will help in resolving problems quickly – should you face any.

Also read: Maintaining Installation Packages


Replicating an Installation Server

An Installation Server can be replicated on to an existing network share using NWCreateInstServer available on the SETUP directory of the Installation Server with the command line:

\\InstallationServerShare\Setup\NwCreateInstServer.exe /Dest=ReplicationPath /NoDlg

Also read: Adding new SAP Front-End Components to an Installation Server


Administering an Installation Server

After you have successfully set up the installation server, you can find NWSAPSetupAdmin.exe in the SETUP directory of the installation server.

NWSAPSetupAdmin.exe is designed to help you administer the multi-product installation server. It supplies the following features:

● Import Product

Use this feature to add new products (for example, SAP front-end components) to an existing installation server for distribution over the network.

● Export Product

Use this feature to export front-end components available on one installation server to another.

● Delete Product

Use this feature to delete a product from an installation server.

● Create Package

Use this feature to create packages for deployment. Packages can contain many components and their installation parameters can also be customized.

● Create Package Definition File (PDF)

You can create a package definition file (PDF) for an installation server package. PDF is a package description format that simplifies the interoperability and information exchange between the SAP Installer and system management products like the System Management Server from Microsoft.

● Configure Package

Use this feature to change the attributes or the content of your packages.

● Patch

Use this feature to patch components that are available on the installation server.

● Local Security Handling

This feature allows workstation users to install SAP components from the installation server without requiring administrative privileges.

NWSAPSetupAdmin.exe requires the .NET Framework 2.0 to be installed as a prerequisite. You can download the .NET Framework from:

http://www.microsoft.com/downloads/details.aspx?familyid=0856EACB-4362-4B0D-8EDD-AAB15C5E04F5

● Configuring SAP Automatic Workstation Update

Whenever the installation server is patched, or the packages installed are updated, this service will update the workstation(s) and reboot them if necessary. The workstation updater works in two modes - one in the presence of a logged-on user and another in his or her absence:

· When a user is logged on, the user is informed of update availability and the update happens on the user's assent. The user is also informed if a reboot is necessary and the reboot is also only executed on the user's assent.

· If no user is logged on, the update is done automatically and the reboot (if necessary) is done automatically, too.

Also read: Maintaining Installation Packages


Adding New SAP Front-End Components to an existing Installation Server

Use

To make SAP Products originally available on a CD or a distributable media ready for deployment via an Installation Server on a network, it is important to first add them to this server.

This wizard-driven process can be performed by NWUpdateInstServer or NWSAPSetupAdmin.exe (via the Import Product Wizard) found in the SETUP directory of the source CD / Medium.

Prerequisites:

  • An existing Installation Server created by following the steps elicited here.
  • A CD or Medium that contains a SAP Product to be inserted into the Installation Server.
  • The Installation Server should not be in use during this period.
  • Availability of adequate disk space.

Procedure

The installation server can be updated with new SAP Components using one of the following two methods:

  • Using NWUpdateInstServer.exe –
    1. Start NWUpdateInstServer.exe from the SETUP directory of the CD / Source containing the component to be added.
    2. Supply the path of the installation server and follow the wizard to update it with components available on the source.

When using NWUpdateInstServer, the steps to be followed are quite similar to what was seen between Steps 4 and 7 of Installation Server Creation.

  • Using NWSAPSetupAdmin.exe –
    1. Start NWSAPSetupAdmin.exe from the SETUP directory of the Installation Server that needs to be updated with the new component.
    2. Click on the toolbar button that states Import Products.
    3. Follow the wizard and supply the path to the source where the product to be inserted into the Installation Server is available.

Also read: Maintaining Installation Packages


Updating Products on the Installation Server with Newer Releases

Use

When newer versions of SAP products and components are released, the administrator needs to update his Installation Server to be able to distribute these updates to the workstations via a Network.

This wizard-driven process is handled by a utility called NWUpdateInstServer found in the SETUP directory of the source CD / Medium.

Prerequisites:

  • A CD or medium that contains a SAP product in a version newer than the one present on an Installation Server.
  • The Installation Server should not be in use during this period.
  • Availability of adequate disk space.

Procedure

The procedure is exactly the same as the one seen in Adding New Products to the Installation Server.

Simply start NWUpdateInstServer from the source CD or medium and follow the wizard.

You can also update products on the Installation Server by using the following command line:

\\UpdateSource\Setup\NwUpdateInstServer.exe /dest=<installation server setup directory> /NoDlg or /silent

See also Command Line Parameters.

Also read: Patching the Installation Server


Patching the Installation Server

Use

Patching products on the installation server keeps them up-to-date with the most recent corrections and enhancements from SAP.

Once a product on the Installation Server has been patched, the workstation installer will prompt the user to update his workstation with that product on the next start.

Prerequisites

  • An existing Installation Server created by following the steps elicited here.

The Installation Server should not be in use for a successful, reboot-free patch. One way of ensuring this is to un-share the Installation Server for the duration of the patch process and to re-create the share once the patch is completed.

  • A patch supplied by SAP towards fixing issues with products / components available on the Server.

Procedure

  1. Start NWSAPSetupAdmin.exe from the SETUP directory of the Installation Server.
  2. Click the toolbar button titled Patch Server. This starts the patch wizard. Click Next to continue.
  3. Browse to a valid SAP patch file and click Next to continue.
  4. NWSAPSetupAdmin will now validate the patch. This process will take a few minutes.
  5. If the patch is valid, you will be prompted to proceed with it.

As a part of ensuring that the Installation Server is not in use, the patch will now close NWSAPSetupAdmin application before continuing. It will be restarted after the completion of the patch process.

Click Next to continue.

  6. NWUpdateInstServer will now come up to patch the Installation Server. Simply follow the wizards, click Next on the pages that follow to patch your Installation Server.
  7. At the end of the process, you should see a success-status message if applying the patch was successful. Click Finish to complete.
  8. NWSAPSetupAdmin.exe will restart now.
  9. If you have patched a SAP Front-End component (for example: SAP GUI for Windows 710), the version number seen against this component as seen in NWSAPSetupAdmin.exe should increase after the patch.

Diagnosing errors

In event of errors, SAPSetup will provide you with a link titled Create Package Definition File. Clicking it will display errors maintained in NwUpdateInstServerErrors_CurrentDateTime.xml using your default web-browser.

This xml file is saved in the folder: %ProgramFiles%\Sap\SAPSetup\Errors.

A record of process activity is logged in NWUpdateInstServer.log.

This log file is saved in the folder: %ProgramFiles%\Sap\SAPSetup\Logs.

Supplying these two files to SAP Support will help in resolving problems quickly – should you face any.


Configuring Local Security Handling

Deleting Products from the Installation Server

To delete products from the installation server, proceed as follows:

...

1. Start NWSAPSetupAdmin.exe from the SETUP directory of the installation server where you want to delete a product.

2. On the Products tab, right-click the product to be deleted and choose Delete Product.

The product deletion wizard appears.

3. Follow the deletion wizard.

At the end of the deletion process, a message will inform you, if the deletion process completed successfully.

If you delete a product that is still a part of a preselection package, the indicator [image] appears next to name of the affected package on the Packages tab. This indicates that a product that is a part of the package is not available on the installation server. Thus, either the package has to be deleted or the product must be re-imported into the server from another source.


Configuring Local Security Handling

Use

Local Security Handling (LSH) when configured successfully allows users on the network to deploy SAP front-end components on their workstation using NetWeaver SAPSetup without requiring administrative privileges on their respective computers.

Workstations that run Windows Vista can make use of Local Security Handling only if Remote Service Configuration in the Firewall Settings is enabled. By default, this option is disabled.

Prerequisites:

An existing Installation Server created by following the steps elicited here.

Procedure

  1. Start NWSAPSetupAdmin.exe from the SETUP folder of the Installation Server.
  2. Click on the Services menu option and then select Configure Local Security Handling.
  3. The LSH Configuration Wizard should start. Click Next to continue.
  4. You will now be prompted to supply the credentials of an account that has administrative privileges over all Workstations on the network. Please, supply the account name with domain-qualifiers, as applicable.

Click Verify. On successful verification, you should see a Next button.

Verification only confirms that the password supplied matches its repetition. Verification does not validate credentials.

Click Next to continue.

  4. Similarly, you will need to supply credentials for the IS-Account. Verify the same and click Next to complete the process.
  5. The wizard should now display the success-state in starting the distribution service and the status bar at the bottom of NWSAPSetupAdmin.exe should display Service State as Active.

It is important to test the functioning of the LSH feature by starting NWSAPSetup.exe from this Installation Server on a workstation where the logged-on user has plain user privileges (i.e. no administrative privileges) on his machine. If the workstation installer starts successfully and is able to install components available on the Installation Server, the configuration was successful.

Else, re-configure LSH using correct credentials.


What’s New in NetWeaver SAPSetup

Configuring SAP Automatic Workstation Update

Use

The SAP Automatic Workstation Update is a new installer feature shipped with compilation 2. It works only when installed on the workstation. Whenever the installation server is patched, or the packages installed are updated, this service will update the workstation(s) and reboot them if necessary. The workstation updater works in two modes - one in the presence of a logged-on user and another in his or her absence:

● When a user is logged on, the user is informed of update availability and the update happens on the user's assent. The user is also informed if a reboot is necessary and the reboot is also only executed on the user's assent.

● If no user is logged on, the update is done automatically and the reboot (if necessary) is done automatically, too.

This service updates itself, when a patch of automatic workstation update is available.

Prerequisites

The workstation side needs a network connection to the installation source for any update to be possible.

On the installation server side, the following prerequisites must be met:

● The installation server should be hosted on a machine that can work as a file-server and serve numerous network sessions.

● Windows Server 2003 (or equivalent) is recommended as the installation server operating system with the following ‘Local Security Policy’:

○ “Accounts: Guest account status” – Enabled.

○ “Network Access: Let Everyone permissions apply to anonymous users” - Enabled.

● The installation server should be created (and hence configured) using NWCreateInstServer.exe.

Procedure

In order to configure automatic workstation update, proceed as follows:

1. Open the administration tool NWSapSetupAdmin.exe.

2. Choose Services -> Configure automatic update.

The screen Automatic Workstation Update Configurations appears as shown in the following picture:

You have now several options:

○ Update re-check frequency

The workstations that will have this feature installed, will poll the installation server at this interval to check for update availability. The default is 24 hours.

○ Enforce reboot after every update

When this flag is not set, the user is asked to reboot only if it is required to complete the deployment process. When the flag is set, a reboot is enforced, which means that the user is always asked to reboot.

○ Additional Update Sources (optional)

You can index additional servers. The update service will then look up the indexed servers per line in the given order for available updates.

3. Save your entries and close the program.

To make the automatic workstation update service available on workstations, you should create a package using NWSapSetupAdmin.exe on the installation server. This package should consist of the components to be installed and SAP Automatic Workstation Update. Once automatic workstation update is installed, then the following programs will run on the workstation in the background: NWSAPSetupUserNotificationTool.exe and NWSAPAutoWorkstationUpdateService.exe.

The front-end side will query the last 10 installation sources that are network paths.

Result

You have configured the SAP Automatic Workstation Update and made it available on the workstations.

To disable the service, activate the option Disable Automatic Workstation Update in the configuration tool on the installation server (see picture above). This action is propagated as an update to the workstations.

Once disabled, this action cannot be undone until the Automatic Workstation Update Service is reinstalled.


Maintaining Installation Packages

After setting an installation server up, administrators can create “packages” for installation by users. The tool used by administrators for this purpose is NWSAPSetupAdmin and can be found in the SETUP folder on the installation server.

Package creation and deployment in SAPSetup is enabled on a multiple-product level allowing the administrator of the Installation Server to create packages comprising of more than one SAP Front End product, components and parts thereof.

Also Read: Creating a New Installation Package


Creating a New Installation Package

Procedure

...

1. Start NWSAPSetupAdmin from the SETUP folder of your Installation Server.

2. Click on the toolbar button titled New Package. This starts the Package Creation Wizard.

3. Click Next to continue.

The wizard will present components available on the Installation Server:

4. Select the products that you want to add to your package.

Yellow dots indicate changes in the selection list. The green plus signs next to the product
names indicate that these products will be installed when the user installs the package on
his or her workstation.

Choose Next. You will be prompted for a package name.

5. Enter a name, and click Next to create the package.

6. NWSAPSetupAdmin will now create a package and confirm success. Click Finish and return to NWSAPSetupAdmin.

7. The newly created package should now be visible in the Package View.

Right-click a package and click Configure to customize installation parameters such as installation path for components contained in the package.


Configuring Packages and Scripting Events

Purpose

Package configuration lets the administrator change the attributes of a package (for example, the name), give the package a description and customize the installation of the package by adding scripts that are to be executed during events in the package deployment cycle.

Prerequisites

● An Installation Server created using the steps elicited here.

● Packages created by the administrator and available for customization.

Process Flow

  1. Start NWSAPSetupAdmin.exe from the SETUP directory of the Installation Server.
  2. Switch to the Configure Packages tab. In the left window pane, you can see a tree listing the existing packages.

The indicator [image] next to a package indicates that the package is incomplete. This typically occurs when a product that the package contains has been deleted from the installation server. You can either delete this package or re-import the missing product.

  3. Select the package that you wish to customize.
    You can now change the name of the package, or add a description, or even script events.

The text supplied as description will eventually be visible to the end-user wishing to install the package using NWSAPSetup.exe.

  4. Add event-scripting to perform custom actions on the user’s workstation during the installation of the package. You can insert scripting samples delivered by SAP via Insert Script and adapt them to your requirements. The scripts will be executed at the following events:
    1. On Begin Install: Executed before the installation of a selected Package.
    2. On End Install: Executed after the completion of installation of a Package.
    3. On Begin Uninstall: Executed before the uninstallation of a selected Package.
    4. On End Uninstall: Executed after the completion of the uninstallation of a Package.
    5. On Begin Update: Executed before the update of a selected Package.
    6. On End Update: Executed after the completion of the Package update.

To learn more about the package update option see Changing the Package Content.

  5. Remember to click the Save button to persist changes made.

This is an advanced feature. Please, always test your scripts before deployment.

Also read: Changing Package Content | Package Event Scripting Samples


Configuring Packages and Scripting Events

Changing the Package Content

Purpose

The package configuration lets the administrator also update the package content. This means, you can add or remove components to be installed with the package. Also, you can add scripts that are to be executed before or after the update.

Prerequisites

● An Installation Server created using the steps elicited here.

● Packages created by the administrator and available for customization.

Process Flow

  1. Start NWSAPSetupAdmin.exe from the SETUP directory of the Installation Server.
  2. Switch to the Configure Packages tab. In the left window pane, you can see a tree listing the existing packages.

The indicator [image] next to a package indicates that the package is incomplete. This typically occurs when a product that the package contains has been deleted from the installation server. You can either delete this package or re-import the missing product.

  3. Select the package for which you want to update the content, and choose Change Package Content.
    You can now select or deselect components. Components added will be newly installed on the workstations. Those removed will be uninstalled from the workstations, if they are not part of any other package marked for installation. When updating a package, the package installation parameters are also refreshed and include new variables or delete those that belong to components that are no longer part of this package.
  4. Optional: Add event-scripting to perform custom actions on the user’s workstation during the update of the package. You can insert scripting samples delivered by SAP via Insert Script and adapt them to your requirements. The scripts will be executed before and after the update:
    1. On Begin Update: Executed before the update of a selected Package.
    2. On End Update: Executed after the completion of the Package update.
  5. Remember to click the Save button to persist changes made.
    Saving the package increases the version number and the package is marked for update on the workstation. When the package installation is updated on the workstation, the package components that have been newly added or removed by the admininstrator are automatically installed or uninstalled respectively.

If you are using package event-scripting to transfer your files, the Mark for Update link as seen on the Configure Packages tab can be used to inform the installer of the availability of an update after you have modified this file. The installer will now recognize the package as updated and the modifications will be transferred to the workstations at update time via the OnBeginUpdate and /or OnEndUpdate scripts.

Also read: Package Event Scripting Samples


* Package Event Scripting Samples

You can insert scripting samples delivered by SAP via the Insert Script link on the Configure Packages tab and adapt them to your requirements.

Here are some VB-Scripting commands that will help you customize your packages:

  • How to add custom logging to the log-file?
  • How to resolve an installation variable?
  • How to check a file for existence?
  • How to copy a file?
  • How to delete a file?
  • How to copy a directory recursively?
  • How to delete a directory?
  • How to check for the existence of a registry-key?
  • How to set a registry value?
  • How to read a value from the registry?
  • How to execute another application?

Additionaly, some examples are given to customize your SAP GUI packages:

  • Example 1: Copying a customized “SapLogon.ini” and “services”-file
  • Example 2: Setting registry values to pre-configure Auto-Update settings for SAP Logon
  • Example 3: Replacing a line inside a text file
  • Example 4: Modifying the “services”-file on install
  • Example 5: Modifying the “services”-file on uninstall

How to add custom-logging to the log-file?

NwEngine.Context.Log.Write "Event: On Begin Install"

How to resolve an installation variable?

strSrcFile   = NwEngine.Variables.ResolveString("%SapSrcDir%\CustomerFiles\TestFile.txt")
strSrcFolder = NwEngine.Variables.ResolveString("%SapSrcDir%\CustomerFiles")
strDstFolder = "C:\temp\TestFolder"
strDstFile   = "C:\temp\TestFolder\TestFile.txt"
strDstFile1  = NwEngine.Variables.ResolveString("%ProgramFiles%\TestFile.txt")
strDstFile2  = NwEngine.Variables.ResolveString("%CommonProgramFiles%\TestFile.txt")
strDstFile3  = NwEngine.Variables.ResolveString("%WinDir%\TestFile.txt")

How to check a file for existence?

If NwEngine.Shell.FileExist( strSrcFile ) Then
 …
End If

How to copy a file?

NwEngine.Shell.CopyFile szSrcFile, szDstFile

in force-mode (without time-stamp and file-version check):

NwEngine.Shell.CopyFileEx szSrcFile, szDstFile, vbTrue

How to delete a file?

NwEngine.Shell.DeleteFile szDstFile

How to copy a directoy recursively?

NwEngine.Shell.CopyDirectory strSrcFolder, strDstFolder

in force-mode (without time-stamp and file-version check):

NwEngine.Shell.CopyDirectoryEx strSrcFolder, strDstFolder, vbTrue

How to create a directory?

NwEngine.Shell.CreateDirectory strDstFolder

How to delete a directory?

NwEngine.Shell.DeleteDirectory strDstFolder

How to check for the existence of a registry-key?

If NwEngine.Shell.RegKeyExist("HKCU\SOFTWARE\SAP\TestKey") Then

            …

End If

How to set a registry value?

NwEngine.Shell.SetRegValue "HKCU\SOFTWARE\SAP\TestKey\TestString", "REG_SZ", "TestValue"

NwEngine.Shell.SetRegValue "HKCU\SOFTWARE\SAP\TestKey\TestDWord", "REG_DWORD", "65536"

How to read a value from the registry?

szRegValue = NWEngine.Shell.GetRegValue("HKCU\SOFTWARE\SAP\TestKey\TestString")

How to execute another application?

strCmdLine = NwEngine.Variables.ResolveString("%WinDir%\NotePad.exe")

bNoWaiting = vbFalse   'This means: Wait for the started process
NwEngine.Shell.Execute strCmdLine, bNoWaiting

bVisible   = vbFalse   'This means: Do not display the UI of the started process
NwEngine.Shell.ExecuteEx strCmdLine, bNoWaiting, bVisible

Example 1: Copying a customized “SapLogon.ini” and “sercvices”-file:

'This scripting can be added to the “On End Install” section of a SAP GUI 710 package event script.
'It distributes your special version of the “SapLogon.ini” and services file
'given these files exist inside a folder ‘\CustomerFiles’ on your installation server share.
'

NwEngine.Context.Log.Write "Event: Copying customized SapLogon.ini"
strSrcFile = NwEngine.Variables.ResolveString("%SapSrcDir%\CustomerFiles\SapLogon.ini")
strDstFile = NwEngine.Variables.ResolveString("%WinDir%\SapLogon.ini")

If NwEngine.Shell.FileExist( strSrcFile ) Then
      NwEngine.Shell.CopyFile strSrcFile, strDstFile
End If

NwEngine.Context.Log.Write "Event: Copying customized services file"
If NwEngine.Shell.FileExist("%SAPSrcDir%\CustomerFiles\services") Then
      NwEngine.Shell.CopyFile "%SAPSrcDir%\CustomerFiles\services", "%WinSysDir%\drivers\etc\services"
End If

Example 2: Setting registry values to pre-configure Auto-Update settings for SAP Logon:

'This scripting can be added to the “On End Install” section of a SAP GUI 710 package event script to pre-define the auto-update settings for SAP Logon.
NwEngine.Context.Log.Write "Event: Setting the auto-update registry key for SAP Logon"

strRegUpdate = "HKLM\SOFTWARE\SAP\SAPsetup\SAPstart\AutoUpdate\SAPLogon.exe\UpdateMode"
strRegProb   = "HKLM\SOFTWARE\SAP\SAPsetup\SAPstart\AutoUpdate\SAPLogon.exe\Prob"

'Option 1: Update Mode is switched on with update frequency = 10. The user is not allowed to configure.
NwEngine.Shell.SetRegValue strRegUpdate, "REG_SZ", "ForceOn"
NwEngine.Shell.SetRegValue strRegProb, "REG_DWORD", "10"

'Option 2: Update Mode is switched off. The user is not allowed to switch it on.
NwEngine.Shell.SetRegValue strRegUpdate, "REG_SZ", "ForceOff"

'Option 3: Update Mode is switched on with update frequency = 10. The user is allowed to change the configuration.
NwEngine.Shell.SetRegValue strRegUpdate, "REG_SZ", "On"
NwEngine.Shell.SetRegValue strRegProb, "REG_DWORD", "10"

'Option 4: Update Mode is switched off. The user is allowed to change the configuration.
NwEngine.Shell.SetRegValue strRegUpdate, "REG_SZ", "Off"

'The same settings can be applied to the registry values for 'SAPLgPad.exe':
' strRegUpdate = "HKLM\SOFTWARE\SAP\SAPsetup\SAPstart\AutoUpdate\SAPLgPad.exe\UpdateMode"
' strRegProb   = "HKLM\SOFTWARE\SAP\SAPsetup\SAPstart\AutoUpdate\SAPLgPad.exe\Prob"

Example 3: Replacing a line inside a text-file

'This scripting can be added to the “On End Install” section of a SAP GUI 710 package event script
'
'It replaces the default line
' Cmd=""
'by the line
' Cmd="/ini_file="C:\temp\saplogon.ini""
'inside the file “%ProgramFiles%\SAP\SapSetup\setup\SAL\SapLogon.sal”
'
'This way, you can redirect “SAPLogon.exe” to the INI-file “C:\temp\saplogon.ini”.
NwEngine.Context.Log.Write "Event: Editing SAPLogon.sal"

strSalFile = NwEngine.Variables.ResolveString( "%ProgramFiles%\SAP\SapSetup\setup\SAL\SapLogon.sal" )
Set objTextFile = CreateObject("NwSapSetupATLCommon.TextFileParser")
If objTextFile.Parse( strSalFile ) Then
NwEngine.Context.Log.Write "Event: Open and modify the file " & Chr(34) & strSalFile & Chr(34)
      szOldLine = "Cmd=" & Chr(34) & Chr(34)
      szNewLine = "Cmd=" & Chr(34) & "/ini_file=" & Chr(34) & "C:\temp\saplogon.ini" & Chr(34) & Chr(34)
      objTextFile.ReplaceLineEx szOldLine, szNewLine
      objTextFile.Save( strSalFile )
Else
      NwEngine.Context.Log.WriteWarning "Event: Could not open the file " & Chr(34) & strSalFile & Chr(34)
End If

Example 4: Modifying the “services”-file on install

'This scripting can be added to the “On Begin Install” section of a SAP GUI 710 package event script
'
'It checks whether a line containing the string "Alpha" exists.
'If yes, it replaces the line by the line
'"Alpha  1901/tcp"
'Othewise, it simply appends the new line to the end of the services file.
'
NwEngine.Context.Log.Write "Event: Appending or replacing lines in the services file"

strFile = NwEngine.Variables.ResolveString( "%WinSysDir%\drivers\etc\services" )
Set objTextFile = CreateObject("NwSapSetupATLCommon.TextFileParser")

If objTextFile.Parse( strFile ) Then
      NwEngine.Context.Log.Write "Event: Modify the file " & Chr(34) & strFile & Chr(34)
      If objTextFile.DoesStringExist( "Alpha" ) Then
            objTextFile.ReplaceLineEx "Alpha", "Alpha  1901/tcp"
      Else
            objTextFile.AppendLine "Alpha  1901/tcp"
      End If
      objTextFile.Save( strFile )
Else
      NWEngine.Context.Log.WriteWarning "Event: Could not open the file " & Chr(34) & strSalFile & Chr(34)
End If

Example 5: Modifying the “services”-file on uninstall

'This scripting can be added to the “On End UnInstall” section of a SAP GUI 710 package event script
'
'It removes a line from the services files which was set in the last Example 4.
'
NwEngine.Context.Log.Write "Event: Removing a line from the services file"

strFile = NwEngine.Variables.ResolveString( "%WinSysDir%\drivers\etc\services" )
Set objTextFile = CreateObject("NwSapSetupATLCommon.TextFileParser")

If objTextFile.Parse( strFile ) Then
      NwEngine.Context.Log.Write "Event: Modify the file " & Chr(34) & strFile & Chr(34)
      objTextFile.RemoveLine "Alpha  1901/tcp"
      objTextFile.Save( strFile )
Else
      NwEngine.Context.Log.WriteWarning "Event: Could not open the file " & Chr(34) & strSalFile & Chr(34)
End If


Configuring Local Security Handling

Creating a Package Definition File

Use

You can create a package definition file (PDF) for an installation server package. PDF is a package description format that simplifies the interoperability and information exchange between the SAP Installer and system management products like the System Management Server from Microsoft.

Procedure

Proceed as follows to create a package definition file:

...

1. If not already started it, start NWSAPSetupAdmin.exe from the SETUP directory of the installation server.

2. On the Packages tab, right-click the package for which you want to create a PDF-file and choose Create Package Definition File.

3. Choose the directory where you want to save the file, enter a file name, and choose Save.

Result

NWSAPSetupAdmin.exe creates a PDF and an SMS file in the specified directory.


Deleting a Package

1. Switch to Package View.

2. Right-Click on the package you wish to delete.

3. Choose “Delete Package” from the menu that comes up.

4. The package will be deleted, and erased from the “Package View”.


Viewing Log Files and Reporting Errors

All the installation tools described in this document maintain a record of their activity in the form of log-files that can be found under:

● %ProgramFiles%\Sap\SAPSetup\Logs

Each tool maintains the last ten LOG files.

Errors in particular are persisted in an XML Format in files that can be viewed in any browser window and can be found in the folder:

● %ProgramFiles%\Sap\SAPSetup\Errors

To report errors faced in using any particular tool to SAP, supplying the LOG and the ERROR files will help in quicker resolution.

Name of the Utility | Name of the Log File in: %ProgramFiles%\Sap\SAPSetup\Logs | Name of the Error XML File in: %ProgramFiles%\Sap\SAPSetup\Errors
NWCreateInstServer.exe | NWCreateInstServer.log | NwCreateInstServerErrors _<datetime>.xml
NWUpdateInstServer.exe | NWUpdateInstServer.log | NwUpdateInstServerErrors _<datetime>.xml
NWSAPSetupAdmin.exe | NwSAPSetupAdmin.log | NWSAPSetupAdminErrors _<datetime>.xml
NWSAPSetup.exe | NWSAPSetup.log | SAPSetupErrors _<datetime>.xml

Also read: Diagnosing an Installation Server | Troubleshooting and FAQs


Diagnosing an Installation Server

To check your Installation Server start NWSAPSetupAdmin.exe from the SETUP folder and click on the toolbar-button titled “Check Server”. This is a wizard driven feature that tests the integrity of an Installation Server by detecting and confirming the presence of files required for the installation of components that the server can distribute.

If the check process detects errors, it will be provide you with a report containing the necessary details.

Also read: Troubleshooting and FAQs


Troubleshooting and FAQs

This section will address some issues and frequently asked questions with the SAPSetup Installation Server.

  • I get a .NET Security Warning on starting NWSAPSetupAdmin.exe. What should I do?
  • I have some new SAP Front-End Products / Components in a CD. How do I add them to the Installation Server?
  • How can I update my installation software i.e. SAPSetup?
  • I have configured Local Security Handling (LSH), but am not able to install on workstations using an account with non-administrative privileges. What should I do?
  • I have configured Local Security Handling but can’t install using SAPSetup on workstations running Windows Vista. What should I do?
  • How can I create an Installation Server silently - using a command-line?
  • How can I remove components existing on the Installation Server?
  • How do I remove my Installation Server?
  • Where can I find the latest SAP Patches?
  • What information do I need to supply when reporting installation issues to SAP Support?
  • What are the prerequisites for using SAP Automatic Workstation Update?
  • How do I configure SAP Automatic Workstation Update?
  • How do I check if the SAP Automatic Workstation Update works in my environment?
  • I have configured the SAP Automatic Workstation Update, but the workstations are not able to update themselves. What should I do?

Q. Why do I get a .NET Security Warning on starting NWSAPSetupAdmin.exe?

A. You face this problem only when starting NWSAPSetupAdmin from a Network location on your computer.

The NET Framework features a security system called Code Access Security Policy (CASPOL). This features restricts the access granted to .NET executables (like NWSAPSetupAdmin.exe), and the Framework installed on the computer needs to be explicitly informed to trust this assembly (NWSAPSetupAdmin.exe). When the installation server is created using NWCreateInstServer.exe, this utility configures CASPOL on that computer and marks NWSAPSetupAdmin.exe as a trusted assembly. However, this setting is local to the computer that was used to create the Installation Server, and specific to the server’s network path.

Hence, when NWSAPSetupAdmin is started on another computer, or from another network path, you face the security warning.

Follow the steps mentioned in the security warning message box to solve the problem.

Q. I have some new SAP Front-End Products / Components in a CD. How do I add them to the Installation Server?

A. Use NWUpdateInstServer.exe on the CD as mentioned here.

Q. How can I remove components existing on the Installation Server?

A. This feature will be made available in the next version of NWSAPSetupAdmin.exe

Q. How can I update my installation software i.e. SAPSetup?

A. Every time you add a new Product (i.e. SAP Components) to the Installation Server, the Installation Software will automatically update itself to the latest available version. Alternatively, if SAP released a SAPSetup Patch, you can use the Patch Wizard to update your Installation Server Software.

Q. I have configured Local Security Handling (LSH), but am not able to install on workstations using an account with non-administrative privileges. What should I do?

A. Check the privileges supplied to the LSH Configuration Wizard . You may need to supply the Domain Name along with the User ID.

Q. I have configured Local Security Handling but can’t install using SAPSetup on workstations running Windows Vista. What should I do?

A. You need to adjust the Windows Firewall options to switch Remote Service Configuration on. This option is switched off by default.

Q. How can I create an Installation Server silently - using a command-line?

A. Execute the following command-line from the SETUP directory of a source CD or an existing Installation Server:

NWCreateInstServer.exe /ServerPath=”<valid destination path>” /silent

This will not only create a new installation server, but also transfer all products / SAP Components available on the source server to the newly created one.

Q. Where can I find the latest SAP Patches?

A. In the SAP Service Marketplace (http://service.sap.com).

Q. How do I remove my Installation Server?

A. You can remove i.e. delete an installation server when it is no longer in use.

  • If Local Security Handling was configured, start NWSAPSetupAdmin.exe and stop it using the Services menu.
  • First un-share the folder so that the Installation Server is not available to Workstations on the network
  • Delete the folder from the File-System using Windows Explorer.

Q. What information do I need to supply when reporting installation issues to SAP Support?

A. In addition to a description of the problem, an attachment containing the relevant LOG Files and Error XML Files would help in quicker diagnosis of the problem.

Q. What are the prerequisites for using SAP Automatic Workstation Update?

A. See section Configuring SAP Automatic Workstation Update.

Q. How do I configure SAP Automatic Workstation Update?

A. If the product SAP Automatic Workstation Update is available on your Installation Server, the menu option Services -> Configure automatic update should be visible to help you configure this feature. See also section Configuring SAP Automatic Workstation Update.

Q. How do I check if SAP Automatic Workstation Update works in my environment?

A. First create a package using NWSAPSetupAdmin.exe that contains the components you wish to install and the product SAP Automatic Workstation Update. Install the package on a workstation. On the Installation Server side, mark the package as updated, insert an On Begin Update-script, and save you settings. On the workstation side, you can either wait for the update frequency check interval or you simply restart the SAP Workstation Update Service from Control Panel -> Services.

Q. I have configured the SAP Automatic Workstation Update, but the workstations are not able to update themselves. What should I do?

A. Check if your Installation Server is on a Windows Server 2003 (or equivalent). You should have created the Installation Server with the tool NwCreateInstServer.exe.


SAPSetup Command-Line Parameters

Command-Line Parameters for Installation Server Creation and Update

In this section, you find the command line parameters for installation server creation (NWCreateInstServer.exe) and update (NWUpdateInstServer.exe).

NWCreateInstServer/ NWUpateInstServer Parameter | Description
/Dest | Use this parameter to supply the destination folder where you wish to create your installation server. Sample: /Dest=”C:\MyInstServerPath”
/noDlg | Shows only the progress dialog Displays no other user interface. You can use it instead of /silent, if you wish to see progress. If using /noDlg, you need to supply the destination server path via /Dest.
/silent | Displays no user interface – not even progress If using /silent, you need to supply the destination server path via /Dest.
/DontConfigureServerPath | Disables the automatic installation source folder configuration (network share creation and null-session accessiblity).

You can use command-line parameters to automatically replicate your (master) installation server across multiple locations.


What’s New in NetWeaver SAPSetup?

NetWeaver SAPSetup is SAP's New Front-End Software Management Tool.

New Tools and Utilities

For the Installation Server

  • Installation Server Creation Tool (NWCreateInstServer.exe): Helps in creating a basic Installation Server and configures.NET Security to administer it over a network path.
  • Installation Server Update Tool (NWUpdateInstServer.exe): Used to update an Installation Server with SAP Front-End Components. This utility will also automatically update older versions existing on an Installation Server by newer ones.
  • Installation Server Administration Tool (NWSAPSetupAdmin.exe): Helps in maintaining and configuring an Installation Server, creating packages, importing products, etc.

For the Workstation:

  • Front-End Installation Tool (NWSAPSetup.exe): Used to install SAP Front-End Components available on a distribution media / CD / Installation Server on a Workstation, to update an installation or to perform un-installations.

New Features

On the Installation Server:

  • The Installation Server can be configured to manage and hold many SAP Front-End Components.
  • The "Import Product" feature allows the Administrator to bring new SAP Front-End Components into an existing Installation Server for distribution over the Network.
  • The "Export Product" feature allows the export of an SAP Front-End Component from one Installation Server to another.
  • The "Delete Product" feature allows the deletion of an SAP Front-End Component from an Installation Server.
  • Packages can be configured to contain and deploy multiple SAP Front-End Components.
  • You can create a package definition file (PDF) for an installation server package. PDF is a package description format that simplifies the interoperability and information exchange between the SAP Installer and system management products like the System Management Server from Microsoft.

On the Workstation:

  • This one installer is capable of managing multiple SAP Front-End Components deployed on the Workstations.
  • With the new installer, it is possible to install new components, uninstall existing ones and update the rest in one cycle.
  • It features the installation and maintenance of multiple SAP Front-End Components on the Workstation using a single command-line.

Error Management and Logging

  • The tools mentioned above record errors in specific in an XML file that can be found inside %ProgramFiles%\Sap\SAPSetup\Errors. This file can be viewed in any browser as a web-page.
  • Log files are maintained under %ProgramFiles%\Sap\SAPSetup\Logs.

If you face problems in using the new installation tool, remember to visit the Troubleshooting and FAQs page.

Also Read: Setting Up an Installation Server